package com.company.demo.view.sandbox;

import com.company.demo.component.slider.Slider;
import com.company.demo.view.main.MainView;
import com.vaadin.flow.component.ClickEvent;
import com.vaadin.flow.router.Route;
import com.vaadin.flow.server.auth.AnonymousAllowed;
import io.jmix.flowui.Notifications;
import io.jmix.flowui.kit.component.button.JmixButton;
import io.jmix.flowui.view.StandardView;
import io.jmix.flowui.view.Subscribe;
import io.jmix.flowui.view.ViewController;
import io.jmix.flowui.view.ViewDescriptor;
import org.springframework.beans.factory.annotation.Autowired;

@Route(value = "sandbox", layout = MainView.class)
@ViewController("SandboxView")
@ViewDescriptor("sandbox-view.xml")
@AnonymousAllowed
public class SandboxView extends StandardView {

    @Autowired
    private Notifications notifications;
    private Slider slider;

    @Subscribe
    public void onInit(final InitEvent event) {
        slider = new Slider();
        slider.setWidth("25em");
        getContent().addComponentAtIndex(0, slider);
        slider.addValueChangeListener(changeEvent ->
                notifications.show("Event: " + changeEvent.getValue(), "Component: " + slider.getValue()));
    }

    @Subscribe("setValueBtn")
    public void onSetValueBtnClick(final ClickEvent<JmixButton> event) {
        slider.setValue(10);
    }

    @Subscribe("showValueBtn")
    public void onShowValueBtnClick(final ClickEvent<JmixButton> event) {
        notifications.show("Value: " + slider.getValue());
    }


}